;compiler: avrasm
;posledni uprava: 4.10.2005
;dotazy na s.maslan@seznam.cz
;MCU - ATmega32
;XTAL - 16MHz, programovat fuse bit CKOPT !!!

	.include "m32def.inc"
	.dseg

DataBuffer:	.byte	1024
	
	.cseg
	.org	$000	;inicializace
;*******************************************************************************************
;	Inicializace
;*******************************************************************************************
Init:	;pocatecni nastaveni portu a pinu
	ldi	R16,0b11111111
	out	ddra,R16
	ldi	R16,0b11111011
	out	ddrd,R16
	ldi	R16,0b11111111
	out	ddrb,R16
	ldi	R16,0b11111111
	out	ddrc,R16
	sbi	portd,7	;IOWR
	sbi	portd,3	;IORD
	sbi	portb,3	;RAM WR
	sbi	portd,4	;RAM OE
	sbi	portd,6	;A16-A19 buffer CK
	sbi	portd,5	;A8-A15 buffer CK
	cbi	portb,0	;LCD E
	cbi	portb,1	;LCD RS
	cbi	portd,2	;com. tlacitka
	;stack ptr
	ldi	R16,high(ramend)
	out	sph,R16	;nastav SP na konec SRAM
	ldi	R16,low(ramend)
	out	spl,R16	;nastav SP na konec SRAM
	;USART pro prijem/vysilani dat, 8bit, 1 stop, bez parity
	ldi	R16,0b01100010
	out	ucsra,R16
	ldi	R16,0b00011000
	out	ucsrb,R16
	ldi	R16,0b10000110
	out	ucsrc,R16
	ldi	R16,0b00000000
	out	ubrrh,R16
	;hodnoty plati pro XTAL=16MHz
	ldi	R16,16	;115200bd
;	ldi	R16,8	;230400bd
;	ldi	R16,3	;500000bd
;	ldi	R16,1	;1000000bd
;	ldi	R16,0	;2000000bd
	;
	out	ubrrl,R16
	;
	ldi	R16,20
	rcall	DelayLongVar
	;inicializace LCD
	rcall	LCDinit
	;
	rcall	WaitDriveBSY	;cekat az je HDD/CF ready prijimat instrukce
	rcall	WaitDriveRDY	;u HDD jeste cekat na roztoceni
	;
	rcall	IdentIDEdrive	;nacist identifikacni blok
	;
	lds	R16,DataBuffer+1	;ID word, bity 8-15
	bst	R16,7	;bit 15 - non-magnetic drive
	;
	rcall	LCDclrAll	;smaz LCD
	ldi	R16,0b10000000
	rcall	LCDsetPos	;pozice kurzoru na zacatek
	;CF nebo HDD ?
	brts	IDEdriveIsCF
	;HDD (bit 15=0)
	ldi	R30,low(TextHDDT*2)
	ldi	R31,high(TextHDDT*2)
	rjmp	IDEdriveIsHDD
IDEdriveIsCF:	;CF (bit 15=1)
	ldi	R30,low(TextCFT*2)
	ldi	R31,high(TextCFT*2)
IDEdriveIsHDD:	rcall	LCDwrStrFLASH	;napis CF nebo HDD
	;na dalsi radek napis "CHS"
	ldi	R30,low(TextCHSrT*2)
	ldi	R31,high(TextCHSrT*2)
	rcall	LCDwrStrFLASH	;napis CF nebo HDD
	;pocet cylindru
	lds	R16,DataBuffer+2
	lds	R17,DataBuffer+3
	rcall	bin2BCD16p5	;prevod na BCD
	rcall	LCDwrBCD	;na LCD
	;
	ldi	R16,'/'
	rcall	LCDwrChar
	;pocet hlav
	lds	R16,DataBuffer+6
	lds	R17,DataBuffer+7
	rcall	bin2BCD16p5	;prevod na BCD
	rcall	LCDwrBCD	;na LCD
	;
	ldi	R16,'/'
	rcall	LCDwrChar
	;pocet sektrou na stopu
	lds	R16,DataBuffer+12
	lds	R17,DataBuffer+13
	rcall	bin2BCD16p5	;prevod na BCD
	rcall	LCDwrBCD	;na LCD
	;
	rjmp	PC	;konec
	
;*******************************************************************************************
;	texty, 0xFF zakonceni vypisu, 0x00 zalomi radek
;*******************************************************************************************	
TextSpinUpT:	.db	"Roztaceni HDD ...",0xFF
TextIdleT:	.db	"IDLE rezim",0xFF
TextStandbyT:	.db	"STANDBY rezim",0xFF
TextCekDATAT:	.db	"Cekam na DATA z PC",0xFF
TextSecSavedT:	.db	"Sektor ulozen",0xFF
TextSecTXcT:	.db	"Sektor odeslan do PC",0xFF
TextCHSrT:	.db	"C/H/S=",0xFF
TextCFT:	.db	"CompactFlash",0x00,0xFF
TextHDDT:	.db	"HDD",0x00,0xFF
;*******************************************************************************************
;	tady by mely byt vsechny rutiny pro praci s IDE apod.
;*******************************************************************************************
;-------------------------------------------------------------------------------------------
;	nastavi adresu v LBA modu z registru R7:R8:R9:R10
;-------------------------------------------------------------------------------------------
SetLBAadressCom:	rcall	WaitDriveBSY	;cekat na busy
	;D0-D7 jako vystup
	ldi	R16,0b11111111
	out	ddrc,R16
	;pocet sektoru pro pristi zapis/cteni
	ldi	R16,0b00100000	;Sector count registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	out	portc,R6	;pocet sektoru zapisovanych najednou
	rcall	IOWRpulz
	;LBA A0-A7 (sektor)
	ldi	R16,0b00110000	;Sector number registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	out	portc,R7	;LBA A0-A7
	rcall	IOWRpulz
	;LBA A8-A15 (cylindr low)
	ldi	R16,0b01000000	;Cylinder low registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	out	portc,R8	;LBA A8-A15
	rcall	IOWRpulz
	;LBA A16-A23 (cylindr high)
	ldi	R16,0b01010000	;Cylinder high registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	out	portc,R9	;LBA A16-A23
	rcall	IOWRpulz
	;LBA A24-A27 (Drive/Head registr)
	ldi	R16,0b01100000	;Drive/Head registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	ldi	R16,0b11000000	;LBA mod
	or	R16,R10	;LBA A24-A27
	out	portc,R16
	rcall	IOWRpulz
	ret
;-------------------------------------------------------------------------------------------
;	nastavi LBA adresu a vysle instrukci cteni sektoru
;-------------------------------------------------------------------------------------------
SetLBAadressRD:	ldi	R16,1	;pocet sektoru
	mov	R6,R16
	rcall	SetLBAadressCom	;nastavit adresu R7:R8:R9:R10
	rcall	WaitDriveBSY	;pockat na busy
	;cti sektor
	ldi	R16,0b01110000	;Command registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	ldi	R16,0x20	;cti sektor
	out	portc,R16
	rcall	IOWRpulz
	ret
;-------------------------------------------------------------------------------------------
;	nastavi LBA adresu, vysle instrukci zapisu sektrou
;-------------------------------------------------------------------------------------------
SetLBAadressWR:	ldi	R16,1	;pocet sektoru
	mov	R6,R16
	;nasavit adresu
	rcall	SetLBAadressCom
	rcall	WaitDriveBSY
	;zapis sektor
	ldi	R16,0b01110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ldi	R16,0x30	;zapis sektoru
	out	portc,R16
	rcall	IOWRpulz
	ret
;-------------------------------------------------------------------------------------------	
;	zapise sektor ze zasobniku na adresu R7:R8:R9:R10
;-------------------------------------------------------------------------------------------
WRsectorLBA:	ldi	R30,low(DataBuffer)	;zacatek bufferu dat
	ldi	R31,high(DataBuffer)
	;nastavit adresu
	rcall	SetLBAadressWR
	rcall	WaitDataReady	;cekat na povoleni zapisu dat
	rcall	SetDriveDataReg	;nastavit datovy registr
	;zapsat sektor
	ldi	R18,0	;256 slov
WRsectorW:	ld	R16,Z+
	ld	R17,Z+
	out	portc,R16
	out	porta,R17
	cbi	portd,7	;IOWR
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	sbi	portd,7	;IOWR
	dec	R18
	brne	WRsectorW	;dalsi word
	ret
;-------------------------------------------------------------------------------------------	
;	nacte sektor do zasobniku z adresy R7:R8:R9:R10
;-------------------------------------------------------------------------------------------
RDsectorLBA:	ldi	R30,low(DataBuffer)	;zacatek bufferu dat
	ldi	R31,high(DataBuffer)
	;nastavit adresu
	rcall	SetLBAadressRD
	rcall	WaitDataReady
	rcall	SetDriveDataReg
	;data port jako vstup
	ldi	R16,0b00000000
	out	ddra,R16
	out	ddrc,R16
	;precist sektor
	ldi	R18,0	;256 slov
RDsectorR:	cbi	portd,3	;IORD
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in	R17,pina
	in	R16,pinc
	sbi	portd,3	;IORD
	st	Z+,R16
	st	Z+,R17	;ulozit word
	nop
	nop
	dec	R18
	brne	RDsectorR	;dalsi word
	;data port zpet jako vystup 
	ldi	R16,0b11111111
	out	ddra,R16
	out	ddrc,R16
	ret
;-------------------------------------------------------------------------------------------
;	cekat dokud je HDD busy
;-------------------------------------------------------------------------------------------
WaitDriveBSY:	rcall	SetDriveStatReg	;nastavit Status register
WaitDriveBSY1:	rcall	ReadDriveStat	;precist registr
	bst	R16,7	;busy flag
	brts	WaitDriveBSY1	;cekat dokud neni Busy flag log.0
	out	ddrc,R17
	ret
;-------------------------------------------------------------------------------------------
;	cekat na data z HDD
;-------------------------------------------------------------------------------------------
WaitDataReady:	rcall	SetDriveStatReg	;nastavit Status register	
WaitDataReady1:	rcall	ReadDriveStat	;precist registr
	bst	R16,3	;DRQ flag
	brtc	WaitDataReady1	;cekat na log.1
	out	ddrc,R17
	ret
;-------------------------------------------------------------------------------------------
;	cekat dokud neni HDD ready
;-------------------------------------------------------------------------------------------
WaitDriveRDY:	rcall	SetDriveStatReg	;nastavit Status register
WaitDriveRDY1:	rcall	ReadDriveStat	;precist registr
	bst	R16,6	;Drive ready flag
	brtc	WaitDriveRDY1	;cekat na log.1
	out	ddrc,R17
	ret
;-------------------------------------------------------------------------------------------
;	cist registr 
;-------------------------------------------------------------------------------------------
ReadDriveStat:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in	R16,pinc
	sbi	portd,3
	nop
	nop
	ret
;-------------------------------------------------------------------------------------------
;	nastavit status registr
;-------------------------------------------------------------------------------------------
SetDriveStatReg:	in	R17,ddrc	;zaloha stavu portc
	ldi	R16,0b00000000
	out	ddrc,R16	;portc jako vstup
	ldi	R16,0b01110000
	out	porta,R16	;status registr
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	ret
;-------------------------------------------------------------------------------------------
;	nastavit datovy registr
;-------------------------------------------------------------------------------------------
SetDriveDataReg:	ldi	R16,0b00000000	;datovy registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	ret
;-------------------------------------------------------------------------------------------
;	pulz na IOWR
;-------------------------------------------------------------------------------------------
IOWRpulz:	nop
	nop
	cbi	portd,7
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	sbi	portd,7
	nop
	nop
	ret
;--------------------------------------------------------------------------------------------
;	posli prikaz IDE zarizeni
;--------------------------------------------------------------------------------------------
IDEcommand:	ldi	R17,0b01110000	;Command registr
	rcall	IDEregWrite
	ret
;--------------------------------------------------------------------------------------------
;	zapis do hodnoty R16 do registru s adresou R17
;--------------------------------------------------------------------------------------------
;registry:	R17 = 0b00000000	;data registr
;	R17 = 0b00010000	;error/features registr
;	R17 = 0b00100000	;Sector count registr
;	R17 = 0b00110000	;Sector number registr
;	R17 = 0b01000000	;Cylinder low registr
;	R17 = 0b01010000	;Cylinder high registr
;	R17 = 0b01100000	;Drive/Head registr
;	R17 = 0b01110000	;command/status registr
IDEregWrite:	push	R16
	push	R17
	rcall	WaitDriveBSY	;pockat na busy
	pop	R17
	out	porta,R17	;adresa
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	pop	R16
	out	portc,R16	;prikaz na port
	rcall	IOWRpulz
	ret
;--------------------------------------------------------------------------------------------
;	nastavi fyzickou geometrii disku, z identifikacniho retezce
;--------------------------------------------------------------------------------------------
SetDriveParam:	ldi	R30,low(DataBuffer+6)
	ldi	R31,high(DataBuffer+6)
	ld	R10,Z+	;pocet hlav
	dec	R10	;(pocet hlav)-1
	adiw	R30,5
	ld	R6,Z+	;pocet sektoru na stopu
	
	rcall	SetLBAadressCom	;nastavit registry
	rcall	WaitDriveBSY	;cekat na busy
	;
	ldi	R16,0x91	;Set Drive Parameters
	rcall	IDEcommand
	;
	rcall	WaitDriveBSY
	ret
;--------------------------------------------------------------------------------------------	
;	identifikace zarizeni na IDE
;--------------------------------------------------------------------------------------------
IdentIDEdrive:	ldi	R16,0b11111111	;data port jako vystup
	out	ddrc,R16
	;command registr
	ldi	R16,0b01110000	;Command registr
	out	porta,R16
	cbi	portd,5
	sbi	portd,5	;nacist do bufferu
	;
	ldi	R16,0xEC	;identifikace
	out	portc,R16
	rcall	IOWRpulz
	;
	rcall	WaitDataReady	;cekat na DRQ
	rcall	SetDriveDataReg	;status registr
	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)	;zacatek bufferu dat
	ldi	R16,0b00000000	;data port jako vstup
	out	ddra,R16
	out	ddrc,R16
	ldi	R16,0b11111111	;zvedaci odpory
	out	porta,R16
	out	portc,R16
	;
	ldi	R19,0	;256x word do zasobniku
ReadIdentSector:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in	R17,pina	;nacist high byte
	in	R16,pinc	;nacist low byte
	sbi	portd,3
	st	Z+,R16
	st	Z+,R17
	dec	R19
	brne	ReadIdentSector	;dalsi word
	;
	ldi	R16,0b11111111	;data port zase jako vystup
	out	ddrc,R16
	out	ddra,R16
	ret
;-------------------------------------------------------------------------------------------
;	pricte k LBA adrese 16bit cislo R16:R17
;-------------------------------------------------------------------------------------------
LBAadressAdd16:	clr	R15
	add	R7,R16
	adc	R8,R17
	adc	R9,R15
	adc	R10,R15
	ret
;-------------------------------------------------------------------------------------------
;	pricte k LBA adrese 24bit cislo R23:R24:R25
;-------------------------------------------------------------------------------------------
LBAadressAdd24:	clr	R15
	add	R7,R23
	adc	R8,R24
	adc	R9,R25
	adc	R10,R15
	ret
;-------------------------------------------------------------------------------------------
;	pricte k LBA adrese 32bit cislo R0:R1:R2:R3
;-------------------------------------------------------------------------------------------
LBAadressAdd32:	add	R7,R0
	adc	R8,R1
	adc	R9,R2
	adc	R10,R3
	ret
;*******************************************************************************************
;	Rutiny pro praci s externi SRAM
;*******************************************************************************************
;-------------------------------------------------------------------------------------------
;	kopiruje 512B zasobniku interni RAM do exteri na adresu od R3:R4:R5
;-------------------------------------------------------------------------------------------
SectorToSRAMext:	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)
	clr	R14
	inc	R14
	clr	R15
	ldi	R17,0
	ldi	R18,2	;512B
SecToSRAMext1:	ld	R16,Z+
	out	portc,R16	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	cbi	portb,3
	nop
	sbi	portb,3
	;
	dec	R17
	brne	SecToSRAMext1
	dec	R18
	brne	SecToSRAMext1
	ret
;-------------------------------------------------------------------------------------------
;	zapise word R16:R17 na adresu R3:R4:R5 SRAM
;-------------------------------------------------------------------------------------------
Word2SRAM:	clr	R14
	inc	R14
	clr	R15
	;
	out	portc,R16	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	cbi	portb,3
	nop
	sbi	portb,3
	;
	out	portc,R17	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	cbi	portb,3
	nop
	sbi	portb,3
	;
	ret
;-------------------------------------------------------------------------------------------	
;	nacte word ze SRAM z adresy R11:R12:R13 do R16:R17, inkrementuje adresu 
;-------------------------------------------------------------------------------------------
LoadSRAMword:	clr	R14
	inc	R14
	clr	R15
	out	ddrc,R15
	cbi	portd,4
	;
	out	porta,R13
	cbi	portd,5
	sbi	portd,5
	out	porta,R12
	cbi	portd,6
	sbi	portd,6
	out	porta,R11
	add	R11,R14
	adc	R12,R15
	adc	R13,R15
	in	R16,pinc
	;
	out	porta,R13
	cbi	portd,5
	sbi	portd,5
	out	porta,R12
	cbi	portd,6
	sbi	portd,6
	out	porta,R11
	add	R11,R14
	adc	R12,R15
	adc	R13,R15
	in	R17,pinc
	;	
	sbi	portd,4
	dec	R15
	out	ddrc,R15
	ret
;*******************************************************************************************
;	Tady jsou vsechny rutiny pro LCD
;*******************************************************************************************
;--------------------------------------------------------------------------------------------
;	vymaze cele LCD
;--------------------------------------------------------------------------------------------
LCDclrAll:	sbi	portb,1
	ldi	R25,128
LCDclrAll1:	ldi	R16,' '
	rcall	ByteToLCD
	dec	R25
	brne	LCDclrAll1
	ret
;--------------------------------------------------------------------------------------------
;	nastavi pozici na LCD podle R16
;--------------------------------------------------------------------------------------------
LCDsetPos:	cbi	portb,1
	rcall	ByteToLCD
	ret
;--------------------------------------------------------------------------------------------
;	posle znak z R16 na LCD
;--------------------------------------------------------------------------------------------
LCDwrChar:	sbi	portb,1
	rcall	ByteToLCD
	ret
;--------------------------------------------------------------------------------------------
;vypise retezec od adresy udane Z, retezec se ukoncuje 0xFF, radek zalamuje 0x00
;--------------------------------------------------------------------------------------------
LCDwrStrFlash:	sbi	portb,1
LCDwrStrFlash1:	lpm	R16,Z+
	rcall	ByteToLCD
	lpm	R16,Z
	cpi	R16,0
	brne	LCDNeBrLine
	ldi	R16,0b11000000
	rcall	LCDsetPos
	sbi	portb,1
	adiw	R30,1
LCDNeBrLine:	lpm	R16,Z
	cpi	R16,255
	brne	LCDwrStrFlash1
	ret
;--------------------------------------------------------------------------------------------
;	odesle R25 znaku z RAM od ukazatele Z
;--------------------------------------------------------------------------------------------
LCDwrStrRAM:	sbi	portb,1	;data
LCDwrStrRAM1:	ld	R16,Z+
	rcall	ByteToLCD
	dec	R25
	brne	LCDwrStrRAM1
	ret
;-------------------------------------------------------------------------------------------- 	
;	inicializace LCD jako 2 radkovy
;--------------------------------------------------------------------------------------------
LCDinit:	cbi	portb,1
	rcall	ByteToLCDst
	ldi	R16,0b00111000
	rcall	ByteToLCD
	ldi	R16,0b00001100
	rcall	ByteToLCD
	ldi	R16,0b10000000
	rcall	ByteToLCD
	ret
;--------------------------------------------------------------------------------------------
;	posle byte LCD a generuje zpozdeni neco pres 40us	
;--------------------------------------------------------------------------------------------
ByteToLCD:	out	portc,R16
	sbi	portb,0
	nop
	cbi	portb,0
	ldi	R16,185
ByteToLCDL1:	dec	R16
	nop
	brne	ByteToLCDL1
	ret
;--------------------------------------------------------------------------------------------
;	jen zpozdeni po zapnuti (nektere LCD se nechtely inicializovat)
;--------------------------------------------------------------------------------------------
ByteToLCDst:	ldi	R17,5
	ldi	R16,0	
ByteToLCDst1:	dec	R16
	brne	ByteToLCDst1
	dec	R17
	brne	ByteToLCDst1
	ret
;--------------------------------------------------------------------------------------------
;	vypise 5-ciferne BCD cislo bez nul na zacatku z R13:R14:R15
;--------------------------------------------------------------------------------------------
LCDwrBCD:	sbi	portb,1
	clt
	mov	R16,R15
	andi	R16,0b00001111
	subi	R16,-48
	cpi	R16,48
	breq	NextNMBR1
	set
	rcall	ByteToLCD
NextNMBR1:	mov	R16,R14
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR2
	cpi	R16,48
	breq	NextNMBR2
	set
NMBR2:	rcall	ByteToLCD
NextNMBR2:	mov	R16,R14
	andi	R16,0b00001111
	subi	R16,-48
	brts	NMBR3
	cpi	R16,48
	breq	NextNMBR3
	set
NMBR3:	rcall	ByteToLCD
NextNMBR3:	mov	R16,R13
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR4
	cpi	R16,48
	breq	NextNMBR4
	set
NMBR4:	rcall	ByteToLCD
NextNMBR4:	mov	R16,R13
	andi	R16,0b00001111
	subi	R16,-48
	rcall	ByteToLCD
	ret
;*******************************************************************************************
;	tady zacina matematika
;*******************************************************************************************
;------------------------------------------------------------------------------------------------------------------------
; bin2BCD16p5 - 16-bit binary to 5-digit packed BCD conversion (0..65535)
; prevod 16-bit binarniho cisla na peticiferne cislo v BCD
;
; BCD16res0:BCD16res1:BCD16res2 <- bin16r0:bin16r1
;
; words:  29 + ret
; cycles: 29/185 + ret [min/max]
;
; author: Stanislav Maslan, s.maslan@seznam.cz
;------------------------------------------------------------------------------------------------------------------------
	.def	BCD16res0=R13
	.def	BCD16res1=R14
	.def	BCD16res2=R15
	.def	bin16r0=R16
	.def	bin16r1=R17
	.def	BB16_cnt1=R30
	.def	BB16_cnt2=R31

bin2BCD16p5:	ser	BB16_cnt2
	mov	BCD16res2,BB16_cnt2
BB16p5_L10k:	inc	BCD16res2
	subi	bin16r0,low(10000)
	sbci	bin16r1,high(10000)
	brcc	BB16p5_L10k
	subi	bin16r0,low(-10000)
	sbci	bin16r1,high(-10000)
	ldi	BB16_cnt1,(256-16)
BB16p5_L1k:	subi	BB16_cnt1,(-16)
	subi	bin16r0,low(1000)
	sbci	bin16r1,high(1000)
	brcc	BB16p5_L1k
	subi	bin16r0,low(-1000)
	sbci	bin16r1,high(-1000)
	mov	BCD16res1,BB16_cnt2
BB16p5_L100:	inc	BCD16res1
	subi	bin16r0,low(100)
	sbci	bin16r1,high(100)
	brcc	BB16p5_L100
	subi	bin16r0,low(-100)
	or	BCD16res1,BB16_cnt1
	ldi	BB16_cnt1,(256-16)
BB16p5_L10:	subi	BB16_cnt1,(-16)
	subi	bin16r0,10
	brcc	BB16p5_L10
	subi	bin16r0,-10
	mov	BCD16res0,BB16_cnt1
	or	BCD16res0,bin16r0
	ret
;*******************************************************************************************
;	Rutiny pro praci s USART
;*******************************************************************************************
;-------------------------------------------------------------------------------------------
;	prijme 512B dat z USARTu do data bufferu
;-------------------------------------------------------------------------------------------
RxSectorCOM:	in	R16,udr
	in	R16,udr	;vyprazdnit udr
	;
	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)
	ldi	R26,low(512)
	ldi	R27,high(512)	;512B
	;
RxSectorCOM1:	sbis	ucsra,rxc	;cekat na byte pres USART
	rjmp	RxSectorCOM1
	;
	in	R16,udr
	st	Z+,R16	;ulozit byte
	;
	sbiw	R26,1	;dalsi byte
	brne	RxSectorCOM1
	ret
;-------------------------------------------------------------------------------------------
;	odesle 512B z data bufferu pres USART
;-------------------------------------------------------------------------------------------
TxSectorCOM:	in	R16,udr
	in	R16,udr	;vyprazdnit udr
	;
	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)
	ldi	R26,low(512)
	ldi	R27,high(512)	;512B
	;
TxSectorCOM1:	ld	R16,Z+
	out	udr,R16	;odeslat byte
	;
TxSectorCOM2:	sbis	ucsra,udre
	rjmp	TxSectorCOM2
	;
	sbiw	R26,1	;dalsi byte
	brne	TxSectorCOM1
	ret
;*******************************************************************************************
;	Rutiny zpozdeni
;*******************************************************************************************	
;-------------------------------------------------------------------------------------------
;	nastavitelne dlouhe zpozdeni (R16)
;-------------------------------------------------------------------------------------------
DelayExtendVar:	clr	R0
	clr	R1
	clr	R2
DelEvar:	dec	R2
	brne	DelEvar
	dec	R1
	brne	DelEvar
	dec	R0
	brne	DelEvar
	dec	R16
	brne	DelEvar
	ret
;-------------------------------------------------------------------------------------------
;	nastavitelne zpozdeni (R16)
;-------------------------------------------------------------------------------------------
DelayLongVar:	clr	R0
	clr	R1
DelLvar:	dec	R1
	brne	DelLvar
	dec	R0
	brne	DelLvar
	dec	R16
	brne	DelLvar
	ret
;-------------------------------------------------------------------------------------------
;	nastavitelne kratke zpozdeni (R16)
;-------------------------------------------------------------------------------------------
DelayShortVar:	clr	R0
DelSvar:	dec	R0
	brne	DelSvar
	dec	R16
	brne	DelSvar
	ret


